set schema FN24_45803;

CREATE TABLE USER(
    ID INT NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
    EMAIL VARCHAR(30) UNIQUE NOT NULL,
    PASSWORDHASH VARCHAR(100) NOT NULL,
    FNAME VARCHAR(30),
    LNAME VARCHAR(30),
    PRIMARY KEY (ID)
);

CREATE TABLE LOGFILE(
    HASH VARCHAR(255) NOT NULL,
    USERID INT NOT NULL,
    TIMESTAMP TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
    NAME VARCHAR(30) CHECK ( NAME != '' ),
    CONTENT CLOB,
    PRIMARY KEY (HASH, USERID)
);

CREATE TABLE LOGHISTORY(
    ID INT NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1),
    USERID INT,
    TIMESTAMP TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
    FILENAME VARCHAR(30),
    PRIMARY KEY (ID)
);

--ADD CONSTRAINTS

ALTER TABLE LOGFILE ADD CONSTRAINT fk_file_userid FOREIGN KEY (USERID) REFERENCES USER (ID) ON DELETE CASCADE;

ALTER TABLE LOGHISTORY ADD CONSTRAINT fk_history_userid FOREIGN KEY (USERID) REFERENCES USER (ID) ON DELETE CASCADE;